#include <stdio.h>


int main(int argc, char** argv){

/*  <stdio.h>
	
	FILES
		fopen 		(abre y crea un archivo en disco)
		fclose 		(cierra un archivo que se ha abierto)
		feof 		(evalúa fin de archivo - End Of File)
		rewind 		(sitúa el cursor de lectura/escritura al principio del archivo)
		fseek 		(sitúa el cursor del archivo a un punto arbitrario)
	READ
		fgetc 		(lee un caracter a la vez de un archivo)
		fgets 		(lee cadenas de caracteres de un archivo)
		fread 		(lee un bloque de una "stream" de datos)
		fscanf 		(funciona igual que scanf, pero tomando un archivo)
	WRITE
		fputc 		(escribe un carácter a la vez en un archivo)
		fputs		(escribe una cadena de caractéres en un archivo)
		fwrite 		(escribie hacia un archivo)
		fprintf     (igual que printf, pero escribe en un archivo)
*/

	if (argc !=2){
		printf("ERROR! Cantidad de argumentos inválida.\n");
		return -1;
	}
	
	FILE *f = NULL;

	/*
	 * Con "r" abrirmos el archivo para leer
	 * Con "w" creamos un archivo para escribir, descartamos contenido anterior
	 * Con "a" creamos un archivo para escribir, escribimos al final del archivo
	 * Con "r+" abrimos un archivo como lectura y escritura
	 * Con "w+" abrimos un archivo como lectura y escrtura, descartamos el contenido anterior
	 * Con "a+" abrimos un archivo como lectura y escritura, comenzamos a escribir al final del archivo
	 */

	// FILE *fopen(const char *filename, const char *mode)

	f = fopen(argv[1], "w+");
	if (f==NULL){
		printf("ERROR! No se pudo abrir el archivo.\n");
		return -2;
	}




	/* Salida con formato: probamos escribir con puts y fprintf*/

		fputs("6\n", f ); // cantidad de lineas que siguen.
    	fputs("1 a 2\n", f ); 
    	fputs("3 b 4\n", f );
    	fputs("4 c 5\n", f );
    	fputs("3 b 4\n", f );
		fputs("5 b 6\n", f );
		fprintf(f, "%d %x %d\n", 8, 15, 5); // Recordar que 15 en decimal es f en hexadecimal. 
    	    	
	fclose(f);


	/* Entrada con formato: probamos leer el archivo escrito previamente con fscanf utilizando el formato establecido y lo escribimos en conosola*/

	f = fopen(argv[1], "r");
	if (f==NULL){
		printf("ERROR! No se pudo abrir el archivo.\n");
		return -2;
	}

	int cantidad_lineas;
	fscanf(f, "%d\n",&cantidad_lineas);
	int i, a, b, c;
	for (i=0;i<cantidad_lineas;i++){
		fscanf(f,"%d %x %d\n",&a,&b,&c);
		printf("%d %x %d\n",a,b,c);
	}
	
	fclose(f);
}